/***********************************************************
 * VKtF07/01/05
 * TODO   ڍsc[
 * Window - Preferences - Java - Code Style - Code Templates
 ***********************************************************/
package jp.co.intra_mart.data_migration;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Properties;

import jp.co.intra_mart.data_migration.common.initialContext;
import jp.co.intra_mart.data_migration.common.read.database.ConnectionProvider;
import jp.co.intra_mart.data_migration.common.table.TableGenerator;
import jp.co.intra_mart.data_migration.common.table.TableGeneratorInfo;
/**
 * @author IM
 * TODO To ISP5.0e[ũf[^ISP6.0e[uɈڍsB
 */
public class ISPMigrationMain {
	//iDBC.propertiespX擾B
	public static final String localeProperityPath  = "locale.properties";

	//iDBC.propertiespX擾B
	public static final String escapeProperityPath  = "escape.properties";

	//o̓t@C̊i[^Cv
	public static  String ENCODE = "";

	//ۉ̌߂ϗ
	public static  String LOCALE = "";

	//GroupingId̓ei[
	private   static   ArrayList  groupingId  = new ArrayList(); 

	//Parent̓ei[
	private   static   ArrayList  groupID  = new ArrayList(); 

	//GroupID̓ei[
	private   static   ArrayList  parent  = new ArrayList();

	//JdbcProperityPatht@C̃pXł Ⴆ΁F "jdbc.properties"
	public   static   String JDBCProperityPath = "";

	//o̓t@C̃pXł@Ⴆ΁F "C:\\temp1\\"
	public static   String outFilePath = "";


	//o̓t@C̊̃R[h
	public static   int recordNumToSlip = 10000;


	//e[uƑΉNX̃Xgꗗ
	private static final TableGeneratorInfo[] CURRENT_GENERATORS = {
/*
		//hLgǗ̈ڍse[uB
		new  TableGeneratorInfo("ispt_document" ,
		"jp.co.intra_mart.data_migration.generator.document.DocumentInfoGenerator"),    
		new  TableGeneratorInfo("ispm_document_access" ,
		"jp.co.intra_mart.data_migration.generator.document.DocumentMasterGenerator"),

		//Z^̈ڍse[uB                
		new  TableGeneratorInfo("ispt_personal_address" ,
		"jp.co.intra_mart.data_migration.generator.address.AddressGenerator"),
		//new  TableGeneratorInfo("ispm_conference_access" ,
		//               "jp.co.intra_mart.data_migration.generator.address.AddressGenerator"), 

		//Z^̈ڍse[uB 
		new TableGeneratorInfo("sfat_dly_daily",
		"jp.co.intra_mart.data_migration.generator.daily.DailyReportGenerator"),     
		new TableGeneratorInfo("sfam_dly_customer",
		"jp.co.intra_mart.data_migration.generator.daily.DailyCustomerGenerator"),
		
		//dqc̈ڍse[uB 
		new TableGeneratorInfo("ispt_conference_info",
		"jp.co.intra_mart.data_migration.generator.bulletin.BulletinInfoGenerator"),
		new TableGeneratorInfo("ispm_conference_access" ,
		"jp.co.intra_mart.data_migration.generator.bulletin.BulletinMasterGenerator"),               

		//{݂̈ڍse[uB 
		new TableGeneratorInfo("ispm_facility" ,
		"jp.co.intra_mart.data_migration.generator.facility.FacilityMasterGenerator"),
		new TableGeneratorInfo("ispm_facility_group" ,
		"jp.co.intra_mart.data_migration.generator.facility.FacilityGroupMasterAndInclusionGenerator"),

		//XPW[̈ڍse[uB
		new TableGeneratorInfo("ispm_personal_access" ,
		"jp.co.intra_mart.data_migration.generator.schedule.ScheduleAuthority"),
		new TableGeneratorInfo("ispt_reserve" ,
		"jp.co.intra_mart.data_migration.generator.schedule.ScheduleReserve"),

		// 07/01/30ΑӂƗ̊֌W
		new  TableGeneratorInfo("ispwrkm_time" ,
		"jp.co.intra_mart.data_migration.generator.business.BusinessInfoGenerator"),
*/
		// ISP60x to ISP61 f
		new TableGeneratorInfo("ispt_bulletin_info", "jp.co.intra_mart.data_migration.generator.isp61.BulletinGenerator"),
		
		// ISP60x to ISP61 dqc
		new TableGeneratorInfo("ispt_conference_info", "jp.co.intra_mart.data_migration.generator.isp61.ConferenceGenerator"),
	}; 

	/**@main֐
	 * @param Ȃ
	 * @throws Exception
	 */
	public static void main(String[] args){  

		for(int i = 0; i < args.length ; i++){			
			//p[^[ڍ׏B
			if(args[i].equals("-help")){
				System.out.print(" Usage:  BigMigration Executer have 2 parameters\n");
				System.out.print(" where options include:\n");
				System.out.print(" parameter1: -JdbcProperityPath  *(must be input)The path of JDBC properity file.\n");
				System.out.print(" parameter2: -output  *(must be input)The path of output file.\n");
				return;
			}

			if(args[i].equals("-propertyPath")){
				if(!checkPath(args[i+1])){
					initialContext.getLogger().warning("The parameter1 is wrong!\n");
					return;	
				}
				//JdbcProperityPatht@C̃pXłBit@C܂ށAK{͍łBj
				JDBCProperityPath  = args[i+1];
			}

			//p[^[̒Q̏ꍇB
			if(args[i].equals("-output")){ 
				if(!checkPath(args[i+1])){
					initialContext.getLogger().warning("The parameter2 is wrong!\n");
					return;	
				}
				//o̓t@C̃pXłBit@C܂ށAK{͍łBj
				String userInputPath = args[i+1];
				outFilePath = userInputPath;	
			}
		}

		if(JDBCProperityPath == null ||JDBCProperityPath == null ){
			initialContext.getLogger().warning("Have parameter  not input! ");
		}

		//------------------------------------
		/* Cv]   Saturday, January 27, 2007 5:41 PM]
		 * (1)-outputŎw肷o̓tH_łA\߂̃tH_
		쐬ĂȂƌʂo͂ƂɃG[ɂȂ
		܂܂Bƕse؂Ȃ̂ŏo̓tH_Ȃꍇ
		ɂ̓vOŎō쐬悤ɂĂB
		 */

		//͂pXSĊKw̃tH_āA݂ȂtH_𐶐B
		String filePathForCheck =  outFilePath;
		//pXfp̕ϗ
		String remainPath = "";
		int    length = 0;
		String sep = File.separator;
		
		//pXL̔f
		if(filePathForCheck != null){
			try{
				//pX̒Ɂh\hȂ̏ꍇ́AtH_̐I
				while(filePathForCheck.indexOf(sep) != -1){	  
					length = length + filePathForCheck.indexOf(sep)+1; 
					filePathForCheck =  filePathForCheck.substring(filePathForCheck.indexOf(sep)+1
							,filePathForCheck.length());
					//pXfp̕ϗʂ擾B
					remainPath = outFilePath.substring(0,length);
					File   remainPathFile   =   new File(remainPath);
					//݂̏ꍇAtH_B
					if(!remainPathFile.exists()){
						remainPathFile.mkdir(); 
					}
				}
				//Ō̏ "C:\temp2\a\b""C:\temp2\a\b\"ǂ炪mpXłB
				if(!outFilePath.substring(outFilePath.length()-1,outFilePath.length()).equals(sep)){
					outFilePath= outFilePath + sep;
				}		
				File   lastPathFile   =   new File(outFilePath);
				//݂̏ꍇAtH_B
				if(!lastPathFile.exists()){
					lastPathFile.mkdir(); 
				}
				else{
					// fBNgɂt@CSď܂B
					File[] files = lastPathFile.listFiles();
					
					for(int i=0; i<files.length; i++){
						files[i].delete();
					}
				}
			}catch (Exception e){
				e.printStackTrace();
				initialContext.getLogger().warning("Create folder Failed!");
			}
		}

		Properties localeModule = new Properties();   	
		try {
			localeModule.load(new FileInputStream(ISPMigrationMain.localeProperityPath));
			//T[oO
			ENCODE = localeModule.getProperty("ENCODE");
			LOCALE = localeModule.getProperty("LOCALE");
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			initialContext.getLogger().warning("localeProperity File Not Found Exception!");
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			initialContext.getLogger().warning("localeProperity File IO Exception!");
		}

		//ConnectionProvideȓΏۂ̐VK
		ConnectionProvider connectionProvider  = new ConnectionProvider();
		//e[^x[XƐڑΏۂ̐VK
		Connection connection = null;
		try {
			connection = connectionProvider.Connection();
		} catch (IOException e) {
			// catch block
			e.printStackTrace();
			initialContext.getLogger().warning("IO Exception!");
		} catch (SQLException e) {
			// catch block
			e.printStackTrace();
			initialContext.getLogger().warning("SQL Exception!");
		} catch (ClassNotFoundException e) {
			// catch block
			e.printStackTrace();
			initialContext.getLogger().warning("Class Not Found Exception!");
		}

		//W[̑SẴe[uJԂŎ擾
		for (int i = 0; i < CURRENT_GENERATORS.length; i++) {
			//{NX̕@Ńe[u擾
			TableGenerator generator = null;
			try {
				generator = (TableGenerator) Class.forName(
						CURRENT_GENERATORS[i].getClassName()).newInstance();
			} catch (InstantiationException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Instantiation get Exception!");
			} catch (IllegalAccessException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Illegal Access Exception!");
			} catch (ClassNotFoundException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Not Found Class, Error!");
			}
			//SQLt@C𐶐B
			try {
				createCurrentSQL( CURRENT_GENERATORS[i].getTable(), generator,connection);
			} catch (Exception e) {
				// catch block
				e.printStackTrace();
			}       
		}
		try {
			//ConnectionfB
			connection.close();
		} catch (SQLException e) {
			e.printStackTrace();
			initialContext.getLogger().warning("connection close Error!");
		}
	}

	/**
	 * @param createCurrentSQL
	 * @param e[u,C^tF[X
	 */
	private static void createCurrentSQL(String tablePrefix, TableGenerator gen , Connection connection)
	{

		//t@C̃f[^t[
		BufferedWriter outBuffer = null;
		//t@C
		gen.setTablePrefix(tablePrefix);
		//t@C̐VK
		//try {
		//outFile = new FileOutputStream(ISPMigrationMain.outFilePath + tablePrefix + ".sql");
		///} catch (FileNotFoundException e1) {
		//    e1.printStackTrace();
		//}
		try {
			//i[obt@[̐VK
			//outBuffer = new BufferedWriter(new OutputStreamWriter(outFile, Charset
			//        .forName(ISPMigrationMain.ENCODE)));
			gen.createSQLFile(outBuffer,connection);    
			//f[^tbV
			//outBuffer.flush();
		} catch (IOException e){
			initialContext.getLogger().info(tablePrefix); 
		}finally {	
			initialContext.getLogger().info(tablePrefix+" ,Create Success!"); 
		}
	}

	/**@NXϗGroupingId̎擾֐
	 * @param Ȃ
	 * @throws Exception
	 */
	public  ArrayList  getGroupingCDArray(){	
		return groupingId; 
	}

	/**@NXϗGroupingId̐ݒ֐@
	 * @param IspGroupingCDArray
	 * @throws Ȃ
	 */
	public  void  setGroupingCDArray(ArrayList IspGroupingCDArray){	
		groupingId   = IspGroupingCDArray; 
	}

	/**@NXϗGroupId̎擾֐
	 * @param Ȃ
	 * @throws Exception
	 */
	public  ArrayList  getGroupCDArray(){	
		return groupID; 
	}

	/**@NXϗGroupId̐ݒ֐@
	 * @param IspGroupingCDArray
	 * @throws Ȃ
	 */
	public  void  setGroupCDArray(ArrayList IspGroupCDArray){	
		groupID   = IspGroupCDArray; 
	}

	/**@NXϗGroupId̎擾֐
	 * @param Ȃ
	 * @throws Exception
	 */
	public  ArrayList  getParentArray(){	
		return parent; 
	}

	/**@NXϗGroupId̐ݒ֐@
	 * @param IspGroupingCDArray
	 * @throws Ȃ
	 */
	public  void  setParentArray(ArrayList IspParentArray){	
		parent   = IspParentArray; 
	}

	/******************************************************************
	 * checkPath  pX̗L̃`FbN
	 * @param originPath@t@C̃p[X
	 * @return boolean
	 * @throws 
	 ******************************************************************/
	public static boolean checkPath(String originPath){
		// pX̖̏ꍇAfalse
		boolean returnCheck = false;      
		if( originPath ==""
			//||(originPath.indexOf(".")== -1)
			||(originPath.length()== 0)
			||(originPath.indexOf("*")!= -1)
			||(originPath.indexOf("?")!= -1)
			//|(originPath.indexOf(":")!= -1)
			||(originPath.indexOf("|")!= -1)
			||(originPath.indexOf("<")!= -1)
			||(originPath.indexOf(">")!= -1)){
		}else{
			returnCheck = true;
		}
		return returnCheck;  
	} 
	
	public static String getFilePath(int i, String tableName){
		if(i <= recordNumToSlip){
			return outFilePath + tableName;
		}
		else if(i > recordNumToSlip && i%recordNumToSlip == 1){
			
		}
		
		return null;
	}
}
