package jp.co.intra_mart.data_migration;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;

/**
 * f[^t@C̍쐬sNX
 * 
 * @author IM
 *
 */
public class InsertFileWriter {
	String tableName;
	
	FileOutputStream outFile;
	BufferedWriter outBuffer;
	
	int counter = 0;
	int page = 0;
	
	/**
	 * ftHgRXgN^
	 */
	public InsertFileWriter() {
		super();
	}

	/**
	 * e[uZbg
	 * 
	 * @param tableName e[u
	 */
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
	
	/**
	 * R[hǉ
	 * 
	 * @param record
	 * @throws IOException
	 */
	public void addRecord(String record) throws IOException{
		if(outFile == null || outBuffer == null){
			outFile = new FileOutputStream(ISPMigrationMain.outFilePath + this.tableName + ".sql",true);
			outBuffer = new BufferedWriter(new OutputStreamWriter(outFile, Charset.forName(ISPMigrationMain.ENCODE)));
		}
		
		if(counter > ISPMigrationMain.recordNumToSlip - 1){
			// y[WԍCNg
			page++;
			
			// gĂt@C
			outBuffer.flush();
			outFile.close();
			
			// ̃t@CJ
			outFile = new FileOutputStream(ISPMigrationMain.outFilePath + this.tableName + page + ".sql",true);
			outBuffer = new BufferedWriter(new OutputStreamWriter(outFile, Charset.forName(ISPMigrationMain.ENCODE)));
			
			// JE^̏
			counter = 0;
		}
		
		outBuffer.write(record);
		
		counter++;
	}
	
	/**
	 * I
	 * 
	 * @throws IOException
	 */
	public void close() throws IOException{
		if(outFile != null && outBuffer != null){
			outBuffer.flush();
			outFile.close();
			outBuffer.close();
		}
	}
}
