/*
 * Created on Jul 6, 2005
 *
 * TODO To change the template for this generated  file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jp.co.intra_mart.data_migration.common;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;

import jp.co.intra_mart.data_migration.common.util.DbUtil;
import jp.co.intra_mart.data_migration.common.util.StringUtil;
import jp.co.intra_mart.data_migration.common.read.CreateRowsException;
import jp.co.intra_mart.data_migration.common.read.Rows;
import jp.co.intra_mart.data_migration.common.read.database.DatabaseReader;
import jp.co.intra_mart.data_migration.ISPMigrationMain;
import jp.co.intra_mart.data_migration.common.util.Identifier;

/**
 * @author mouy
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class BMCommon {

	/**
	 * getUserNameFromUserCD
	 * 
	 * @param userCD, connection
	 * @return SQL 
	 * @throws IOException
	 */    
	public static String getUserNameFromUserCD(String userCD ,String recordDate, Connection connection) 
	throws IOException {

		PreparedStatement statement = null;
		String userName ="";
		StringBuffer sqlUserName = new StringBuffer();

		sqlUserName.append("SELECT uti.user_name ");
		sqlUserName.append("FROM b_m_user_b ub, b_m_user_t ut, b_m_user_t_i uti ");
		sqlUserName.append("WHERE ub.user_cd = ut.user_cd ");
		sqlUserName.append("AND ub.user_cd = uti.user_cd ");
		sqlUserName.append("AND ub.user_cd = ? ");
		sqlUserName.append("AND ut.start_date <= ? ");
		sqlUserName.append("AND ut.end_date > ? "); 
		sqlUserName.append("AND uti.locale_id = ? ");

		try {
			statement = connection.prepareStatement(sqlUserName.toString());

			statement.setString(1,DbUtil.getPaddingString(userCD, userCD.length()));
			statement.setString(2,DbUtil.getPaddingString(recordDate, recordDate.length()));
			statement.setString(3,DbUtil.getPaddingString(recordDate, recordDate.length()));
			statement.setString(4,DbUtil.getPaddingString(ISPMigrationMain.LOCALE, ISPMigrationMain.LOCALE.length()));
		} catch (SQLException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		DatabaseReader databaseReader = new DatabaseReader();
		try {
			Rows rows =  databaseReader.read(connection, statement);			

			if(rows == null) return userName;

			if(rows.getColumns(1).getString(1) == null){	
				userName = userCD;
			}else{
				userName = rows.getColumns(1).getString(1);
			}		
		} catch (CreateRowsException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return userName;
	}

	/**
	 * getAccessLevelFromResourceCD
	 * 
	 * @param resoureCD, connection
	 * @return SQL 
	 * @throws IOException
	 */    
	public static String getAccessLevelFromResourceCD(String resoureCD , Connection connection) 
	throws IOException {
		PreparedStatement statement = null;
		String accessLevel ="";
		StringBuffer sqlUserResource = new StringBuffer();
		sqlUserResource.append("SELECT access_level   ");
		sqlUserResource.append("FROM   ispm_acl ");
		sqlUserResource.append("WHERE  resource_cd = ?  ");

		try {
			statement = connection.prepareStatement(sqlUserResource.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			statement.setString(1,DbUtil.getPaddingString(resoureCD, resoureCD.length()));
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		DatabaseReader databaseReader = new DatabaseReader();
		try {
			Rows rows =  databaseReader.read(connection, statement);

			if(rows == null) return accessLevel;

			//accessLevel = rows.getColumns(1).getString(1);

			if(rows.getColumns(1).getString(1) != null){
				accessLevel = rows.getColumns(1).getString(1);
			}

		} catch (CreateRowsException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return accessLevel;
	}

	/**
	 * ڍsc[ڍא݌v_O[v֘A
	 * getGroupCD
	 * 
	 * @param resoureCD, connection
	 * @return SQL 
	 * @throws IOException
	 */    
	public static String  getGroupCD(String groupingCD,String parentCD , int flagGet,
			String recordCD, String recordRealDate ,String classCD, Connection connection){
		//O[vIDi[ϐ
		String groupCD = "";
		ISPMigrationMain ispMigrationMain = new ISPMigrationMain();
		//GroupingIdGroupId̊i[ϐ
		ArrayList groupingId = new ArrayList();
		ArrayList groupId = new ArrayList();
		ArrayList parentId = new ArrayList();
		//ge֐ŃNXϗʂ擾B
		groupingId = ispMigrationMain.getGroupingCDArray();
		groupId =  ispMigrationMain.getGroupCDArray();
		parentId =  ispMigrationMain.getParentArray();
		//O[v擾B
		int realLength = ispMigrationMain.getGroupingCDArray().size();

		//GroupingCD[̏ꍇ
		if(realLength == 0){
			groupCD = Identifier.make();
			groupId.add(groupCD);
			groupingId.add(groupingCD);
			parentId.add(parentCD);
			writeIspmGroupReference(groupCD,groupingCD, flagGet, recordCD, recordRealDate, 
					parentCD, classCD, connection);
		}else{
			for( int i = 0 ; i < realLength; i++){

				if(groupingId.get(i).equals(groupingCD)&& parentId.get(i).equals(parentCD)){				
					groupCD = groupId.get(i).toString();
					break;
				}
			}
			if(groupCD.equals("")){
				groupCD = Identifier.make();
				groupId.add(groupCD);
				groupingId.add(groupingCD);
				parentId.add(parentCD);

				writeIspmGroupReference(groupCD,groupingCD, flagGet,  recordCD, recordRealDate,
						parentCD, classCD, connection);
			}
		}
		//GroupingCDGroupCDNXɊi[B
		ispMigrationMain.setGroupingCDArray(groupingId);
		ispMigrationMain.setParentArray(parentId);
		ispMigrationMain.setGroupCDArray(groupId);
		return groupCD;
	}

	/**
	 * checkGroupingCD
	 * 
	 * @param groupingCD, connection
	 */    
	public static void  writeIspmGroupReference(String groupCD, String groupingCD, int flagGet , 
			String recordRealCD, String recordRealDate , String parentRealCD,String classRealCD, Connection connection ){
		String groupClsCd = "";
		String recordUserCd = "";
		String recordDate = "";
		String parentCD ="";
		/*O[v֘Ae[u create table ispm_group_reference
		(
		    group_cd                       varchar2(20) not null,
		    group_cls_cd                   varchar2(20),
		    company_cd                     varchar2(20),
		    department_cd                  varchar2(20),
		    public_group_set_cd            varchar2(20),
		    public_group_cd                varchar2(20),
		    role_id                        varchar2(20),
		    owner_cd                       varchar2(50),
		    private_group_cd               varchar2(20),
		    record_user_cd                 varchar2(50) not null,
		    record_date                    varchar2(19) not null
		)create table ispm_acl
         	(
     	    resource_cd                    varchar2(20) not null,
     	    parent_cd                      varchar2(20) not null,
     	    group_cls_cd                   varchar2(20) not null,
     	    grouping_cd                    varchar2(20) not null,
     	    access_level                   varchar2(3) not null,
     	    record_user_cd                 varchar2(20) not null,
     	    record_date                    varchar2(19) not null
        )*/
		PreparedStatement statement = null;
		StringBuffer sqlUserResource = new StringBuffer();
		sqlUserResource.append("SELECT group_cls_cd,   ");
		sqlUserResource.append("record_user_cd,   ");
		sqlUserResource.append("record_date,  ");
		sqlUserResource.append("parent_cd  ");
		sqlUserResource.append("FROM   ispm_acl ");
		sqlUserResource.append("WHERE  grouping_cd = ?  ");
		try {
			statement = connection.prepareStatement(sqlUserResource.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			statement.setString(1,DbUtil.getPaddingString(groupingCD, groupingCD.length()));
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		DatabaseReader databaseReader = new DatabaseReader();
		try {
			Rows rows =  databaseReader.read(connection, statement);
			groupClsCd = StringUtil.TrimNull(rows.getColumns(1).getString(1));
			recordUserCd = StringUtil.TrimNull(rows.getColumns(1).getString(2));
			recordDate = StringUtil.TrimNull(rows.getColumns(1).getString(3));
			parentCD = StringUtil.TrimNull(rows.getColumns(1).getString(4));		

		} catch (CreateRowsException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		String company_cd = "''";
		String department_cd = "''";

		String public_group_cd = "''";
		String public_group_set_cd = "''";

		String owner_cd = "''";
		String private_group_cd = "''";

		String role_id = "''";

		//System.out.println("groupClsCd22222:"+groupClsCd);

		if(flagGet == 1 ){
			groupClsCd = StringUtil.TrimNull(classRealCD);
			parentCD =   StringUtil.TrimNull(parentRealCD);	
		}

		//Ђ̏ꍇ
		if(groupClsCd.equals("'comp'")||groupClsCd.equals("'orgn'")){
			company_cd  = parentCD;
			department_cd = StringUtil.TrimNull(groupingCD);

		}
		//pubNO[v̏ꍇ
		else if(groupClsCd.equals("'official'") || groupClsCd.equals("'public'")){			
			public_group_set_cd  = parentCD;
			public_group_cd = StringUtil.TrimNull(groupingCD);
		}
		//privatȅꍇ
		else if(groupClsCd.equals("'private'")){
			owner_cd  = parentCD;
			private_group_cd = StringUtil.TrimNull(groupingCD);
		}
		//rolȅꍇ
		else if(groupClsCd.equals("'role'")){
				role_id = StringUtil.TrimNull(groupingCD);
		}

		File IspFile=new File(ISPMigrationMain.outFilePath +"ispm_group_reference.sql");
		BufferedWriter outBufferGroupReference = null;
		FileWriter outFileGroupReference = null;
		try {
			if(!IspFile.exists()){
				IspFile.createNewFile();
			}

			outFileGroupReference =new FileWriter(IspFile,true);
			outBufferGroupReference =new BufferedWriter(outFileGroupReference);


			/*57		2007/01/10	Њ֘Ae[uɃR~jeBR[hǉ܂BR							
			 * create table ispm_group_reference
						(
						    group_cd                       varchar2(20) not null,
						    group_cls_cd                   varchar2(20),
						    company_cd                     varchar2(20),
						    department_cd                  varchar2(20),
						    public_group_set_cd            varchar2(20),
						    public_group_cd                varchar2(20),
						    role_id                        varchar2(20),
						    owner_cd                       varchar2(50),
						    private_group_cd               varchar2(20),
						    community_cd                   varchar2(20),
						    record_user_cd                 varchar2(50) not null,
						    record_date                    varchar2(19) not null
						)*/

			outBufferGroupReference.write("INSERT INTO ispm_group_reference ");
			outBufferGroupReference.write("(group_cd,group_cls_cd,company_cd,department_cd,public_group_set_cd,public_group_cd,");
			outBufferGroupReference.write("role_id,owner_cd,private_group_cd,community_cd,record_user_cd,record_date) VALUES(");         

			//group_cd                       varchar2(20) not null,
			outBufferGroupReference.write("'"+groupCD+"',");

			//group_cls_cd                   varchar2(20),
			//o[OC@070115 comp  orgn
			//official  public(ispm_group_reference)group_cls_cd̒ɁAcompofficial
			//ƂR[hlĂ̂U܂B
			if(groupClsCd.equals("'comp'")){
				groupClsCd = "'orgn'";
			}else if(groupClsCd.equals("'official'")){
				groupClsCd = "'public'";
			}
			//System.out.println("groupClsCd:"+groupClsCd);
			outBufferGroupReference.write(groupClsCd+",");

			//company_cd                     varchar2(20),
			outBufferGroupReference.write(company_cd+",");

			//department_cd                  varchar2(20),
			outBufferGroupReference.write(department_cd+",");

			//public_group_set_cd            varchar2(20),
			outBufferGroupReference.write(public_group_set_cd+",");

			//public_group_cd                varchar2(20),
			outBufferGroupReference.write(public_group_cd+",");

			//role_id                        varchar2(20),
			outBufferGroupReference.write(role_id+",");

			//owner_cd                       varchar2(50),
			outBufferGroupReference.write(owner_cd+",");

			//private_group_cd               varchar2(20),
			outBufferGroupReference.write(private_group_cd+",");


			if(flagGet == 1 ){
				recordUserCd = StringUtil.TrimNull(recordRealCD);
				recordDate =   StringUtil.TrimNull(recordRealDate);
			}

			//community_cd
			outBufferGroupReference.write("null,");

			//record_user_cd                 varchar2(50) not null,
			outBufferGroupReference.write(recordUserCd+",");

			//record_date                    varchar2(19) not null
			outBufferGroupReference.write(recordDate+");\n");

			outBufferGroupReference.flush();
			outFileGroupReference.close();

		} catch (IOException e) {
			e.printStackTrace();
		}         
	} 



	/**
	 * getGroupClsFromGroupCD
	 * 
	 * @param GroupCD, connection
	 * @return SQL 
	 * @throws IOException
	 */    
	public static String getGroupClsFromGroupingCD(String groupingCD , Connection connection) 
	throws IOException {
		PreparedStatement statement = null;
		String groupCls ="";
		StringBuffer sqlUserResource = new StringBuffer();
		sqlUserResource.append("SELECT group_cls_cd   ");
		sqlUserResource.append("FROM   ispm_acl ");
		sqlUserResource.append("WHERE  grouping_cd = ?  ");

		try {
			statement = connection.prepareStatement(sqlUserResource.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			statement.setString(1,DbUtil.getPaddingString(groupingCD, groupingCD.length()));
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		DatabaseReader databaseReader = new DatabaseReader();
		try {
			Rows rows =  databaseReader.read(connection, statement);
			groupCls = rows.getColumns(1).getString(1);
		} catch (CreateRowsException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return groupCls;
	}


}