/*
 * ColumnsImpl.java
 *
 * Created on 2005/05/17,  14:08:03
 */
package jp.co.intra_mart.data_migration.common.read;

/**
 * \`f[^̗̎舵̎łB
 *
 * @author intra-mart
 * @since 5.0
 */
public class ColumnsImpl implements Columns {
    /**
     * li[z
     */
    private Object[] values = new Object[0];
    
    /**
     * RXgN^
     * 
     * @param values ƂĐݒ肷l̔z
     */
    public ColumnsImpl(Object[] values) {
        if (values != null) {
            this.values = new Object[values.length];
            System.arraycopy(values, 0, this.values, 0, values.length);
        }
    }
    
    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Columns#getObject(int)
     */
    public Object getObject(int index) {
        return (index < 1 || this.values.length < index) ? null : this.values[index - 1];
    }

    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.read.Columns#getString(int)
     */
    public String getString(int index) {
        Object value = this.getObject(index);
        return (value == null) ? null : value.toString();
    }
    
    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Columns#size()
     */
    public int size() {
        return this.values.length;
    }
}
