/*
 * ResultSetSheet.java
 *
 * Created on 2005/05/17,  16:38:34
 */
package jp.co.intra_mart.data_migration.common.read.database;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.List;
import jp.co.intra_mart.data_migration.common.read.ColumnsImpl;
import jp.co.intra_mart.data_migration.common.read.CreateRowsException;
import jp.co.intra_mart.data_migration.common.read.Rows;
import jp.co.intra_mart.data_migration.common.read.RowsBuilder;
import jp.co.intra_mart.data_migration.common.read.RowsImpl;

/**
 * {@link ResultSet} \`f[^𐶐܂B
 *
 * @author intra-mart
 * @since 5.0
 */
public class ResultSetRowsBuilderImpl implements RowsBuilder {
    /**
     * RXgN^
     */
    public ResultSetRowsBuilderImpl() {
    }

    /**
     * w肳ꂽf[^\[X\`f[^쐬܂B<br>
     * 
     * p[^ɂ {@link java.sql.ResultSet} w肵ĉB
     * 
     * @param source f[^\[X
     * @return \`f[^
     */
    public Rows create(Object source) throws CreateRowsException {
        try {
            ResultSet resultSet = (ResultSet) source;
            List rows = new ArrayList();
            ResultSetMetaData meta = resultSet.getMetaData();
            while (resultSet.next()) {
                List list = new ArrayList();
                for (int i = 1; i <= meta.getColumnCount(); i++) {
                    Object value = resultSet.getObject(i);
                    list.add(value);
                }
                rows.add(new ColumnsImpl((Object[]) list.toArray(new Object[list.size()])));
            }
            return new RowsImpl(rows);
        } catch (Exception e) {
            throw new CreateRowsException(e);
        }
    }
}
