/*
 * ColumnInfo.java
 *
 * Created on 2005/02/01, 20:26:47
 */

package jp.co.intra_mart.data_migration.common.table;

/**
 * J̏łB
 * 
 * @author ohyama
 * @since 5.0
 */
public class ColumnInfo {

    /**
     * J
     */
    private String name;

    /**
     * J^ƃTCY
     */
    private String type;

    /**
     * vC}L[
     */
    private boolean primaryKey;

    /**
     * ԉ
     */
    private boolean terminable;

    /**
     * ۉ
     */
    private boolean international;

    /**
     * NULL
     */
    private boolean nullAcceptable;

    /**
     * ColumnInfoVKɐ܂B
     * 
     * @param name J
     * @param type J^ƃTCY
     * @param primaryKey vC}L[
     * @param terminable ԉ
     * @param international ۉ
     * @param nullAcceptable NULL
     */
    public ColumnInfo(String name, String type, boolean primaryKey,
            boolean terminable, boolean international, boolean nullAcceptable) {
        this.name = name;
        this.type = type;
        this.nullAcceptable = nullAcceptable;
        this.terminable = terminable;
        this.international = international;
        this.primaryKey = primaryKey;
    }

    /**
     * J擾܂B
     * 
     * @return J
     */
    public String getName() {
        return this.name;
    }

    /**
     * Jݒ肵܂B
     * 
     * @param name J
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * J^ƃTCY擾܂B
     * 
     * @return J^ƃTCY
     */
    public String getType() {
        return this.type;
    }

    /**
     * J^ƃTCYݒ肵܂B
     * 
     * @param type J^ƃTCY
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * vC}L[ǂ擾܂B
     * 
     * @return <code>true</code>: vC}L[A <code>false</code>: ʏ̃J
     */
    public boolean isPrimaryKey() {
        return this.primaryKey;
    }

    /**
     * vC}L[ǂݒ肵܂B
     * 
     * @param primaryKey <code>true</code>: vC}L[A <code>false</code>:
     *            ʏ̃J
     */
    public void setPrimaryKey(boolean primaryKey) {
        this.primaryKey = primaryKey;
    }

    /**
     * ԉ\ǂ擾܂B
     * 
     * @return <code>true</code>: ԉA <code>false</code>: ԉĂȂ
     */
    public boolean isTerminable() {
        return this.terminable;
    }

    /**
     * ԉ\ǂݒ肵܂B
     * 
     * @param terminable <code>true</code>: ԉA <code>false</code>:
     *            ԉĂȂ
     */
    public void setTerminable(boolean terminable) {
        this.terminable = terminable;
    }

    /**
     * ۉ\ǂ擾܂B
     * 
     * @return <code>true</code>: ۉA <code>false</code>: ۉĂȂ
     */
    public boolean isInternational() {
        return this.international;
    }

    /**
     * ۉ\ǂݒ肵܂B
     * 
     * @param international <code>true</code>: ۉA <code>false</code>:
     *            ۉĂȂ
     */
    public void setInternational(boolean international) {
        this.international = international;
    }

    /**
     * NULL邩ǂ擾܂B
     * 
     * @return <code>true</code>: A <code>false</code>: s
     */
    public boolean isNullAcceptable() {
        return this.nullAcceptable;
    }

    /**
     * NULL邩ǂݒ肵܂B
     * 
     * @param nullAcceptable <code>true</code>: A <code>false</code>:
     *            s
     */
    public void setNullAcceptable(boolean nullAcceptable) {
        this.nullAcceptable = nullAcceptable;
    }
}