/***********************************************************
 * VKtF07/10/12
 * TODO   ڍsc[
 * Window - Preferences - Java - Code Style - Code Templates
 ***********************************************************/
package jp.co.intra_mart.data_migration;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import jp.co.intra_mart.data_migration.common.initialContext;
import jp.co.intra_mart.data_migration.common.table.TableGenerator;
import jp.co.intra_mart.data_migration.common.table.TableGeneratorInfo;
/**
 * @author nttzy
 * TODO wemailAhXZ^̈ڍse[uB
 */
public class WebMailMigrationMain {
	//Locale.propertiespX擾B
	public static final String localeProperityPath  = "conf/locale.properties";
	
	//	eacape.propertiespX擾B
	public static final String escapeProperityPath  = "conf/escape.properties";
	
	//	̓t@C̃pXpX擾B
	public static  String inputPath  = "";
	
	//o̓t@C̊i[^Cv
	public static  String ENCODE = "";


	//o̓t@C̃pXł@Ⴆ΁F "C:\\temp1\\"
	public static   String outFilePath = "";


	//o̓t@C̊̃R[h
	public static   int recordNumToSlip = 10000;



	//e[uƑΉNX̃Xgꗗ
	private static final TableGeneratorInfo[] CURRENT_GENERATORS = {

		//wemailAhXZ^̈ڍse[uB
		new  TableGeneratorInfo("ispt_personal_address|ispm_group_address|ispt_personal_company" ,
			"jp.co.intra_mart.data_migration.generator.webmail.AddressGenerator"),
	
		
	}; 

	/**@main֐
	 * @param Ȃ
	 * @throws Exception
	 */
	public static void main(String[] args){  

		for(int i = 0; i < args.length ; i++){			
			//p[^[ڍ׏B
			if(args[i].equals("-help")){
				System.out.print(" Usage:  BigMigration Executer have 2 parameters\n");
				System.out.print(" where options include:\n");
				System.out.print(" parameter1: -inputPath  *(must be input)The path of input file.\n");
				System.out.print(" parameter2: -output  *(must be input)The path of output file.\n");
				return;
			}

			if(args[i].equals("-inputpath")){
				if(!checkPath(args[i+1])){
					initialContext.getLogger().warning("The parameter1 is wrong!\n");
					return;	
				}
				//inputPatht@C̃pXłBit@C܂ށAK{͍łBj
				inputPath  = args[i+1];
			}

			//p[^[̒Q̏ꍇB
			if(args[i].equals("-output")){ 
				if(!checkPath(args[i+1])){
					initialContext.getLogger().warning("The parameter2 is wrong!\n");
					return;	
				}
				//o̓t@C̃pXłBit@C܂ށAK{͍łBj
				String userInputPath = args[i+1];
				outFilePath = userInputPath;	
			}
		}

		if(inputPath == null ||inputPath == "" ||outFilePath == null || outFilePath == ""){
			initialContext.getLogger().warning("Have parameter  not input! ");
		}
		
		
		//͂pXSĊKw̃tH_āA݂ȂtH_𐶐B
		String filePathForCheck =  outFilePath;
		//pXfp̕ϗ
		String remainPath = "";
		int    length = 0;
		String sep = File.separator;
		
		//pXL̔f
		if(filePathForCheck != null){
			try{
				//pX̒Ɂh\hȂ̏ꍇ́AtH_̐I
				while(filePathForCheck.indexOf(sep) != -1){	  
					length = length + filePathForCheck.indexOf(sep)+1; 
					filePathForCheck =  filePathForCheck.substring(filePathForCheck.indexOf(sep)+1
							,filePathForCheck.length());
					//pXfp̕ϗʂ擾B
					remainPath = outFilePath.substring(0,length);
					File   remainPathFile   =   new File(remainPath);
					//݂̏ꍇAtH_B
					if(!remainPathFile.exists()){
						remainPathFile.mkdir(); 
					}
				}
				//Ō̏ "C:\temp2\a\b""C:\temp2\a\b\"ǂ炪mpXłB
				if(!outFilePath.substring(outFilePath.length()-1,outFilePath.length()).equals(sep)){
					outFilePath= outFilePath + sep;
				}		
				File   lastPathFile   =   new File(outFilePath);
				//݂̏ꍇAtH_B
				if(!lastPathFile.exists()){
					lastPathFile.mkdir(); 
				}
				else{
					// fBNgɂt@CSď܂B
					File[] files = lastPathFile.listFiles();
					
					for(int i=0; i<files.length; i++){
						files[i].delete();
					}
				}
			}catch (Exception e){
				e.printStackTrace();
				initialContext.getLogger().warning("Create folder Failed!");
			}
		}

		Properties localeModule = new Properties();   	
		try {
			localeModule.load(new FileInputStream(WebMailMigrationMain.localeProperityPath));
			//T[oO
			ENCODE = localeModule.getProperty("ENCODE");
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			initialContext.getLogger().warning("localeProperity File Not Found Exception!");
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			initialContext.getLogger().warning("localeProperity File IO Exception!");
		}


		//W[̑SẴe[uJԂŎ擾
		for (int i = 0; i < CURRENT_GENERATORS.length; i++) {
			//{NX̕@Ńe[u擾
			TableGenerator generator = null;
			try {
				generator = (TableGenerator) Class.forName(
						CURRENT_GENERATORS[i].getClassName()).newInstance();
			} catch (InstantiationException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Instantiation get Exception!");
			} catch (IllegalAccessException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Illegal Access Exception!");
			} catch (ClassNotFoundException e) {
				// catch block
				e.printStackTrace();
				initialContext.getLogger().warning("Not Found Class, Error!");
			}
			//SQLt@C𐶐B
			try {
				createCurrentSQL( CURRENT_GENERATORS[i].getTable(), generator,inputPath);
			} catch (Exception e) {
				// catch block
				e.printStackTrace();
			}       
		}
		
	}

	/**
	 * @param createCurrentSQL
	 * @param e[u,C^tF[X
	 */
	private static void createCurrentSQL(String tablePrefix, TableGenerator gen ,String inputPath)
	{

		//t@C̃f[^t[
		BufferedWriter outBuffer = null;
		//t@C
		gen.setTablePrefix(tablePrefix);
		//t@C̐VK
		try {
			gen.createSQLFile(outBuffer,inputPath);    
			//f[^tbV
		} catch (IOException e){
			initialContext.getLogger().info(tablePrefix); 
		}finally {	
			initialContext.getLogger().info(tablePrefix+" ,Create Success!"); 
		}
	}


	
	/**
	 * pX̗L̃`FbN
	 * @param originPath@t@C̃p[X
	 * @return boolean
	 */
	public static boolean checkPath(String originPath){
		// pX̖̏ꍇAfalse
		boolean returnCheck = false;      
		if( originPath ==""
			//||(originPath.indexOf(".")== -1)
			||(originPath.length()== 0)
			||(originPath.indexOf("*")!= -1)
			||(originPath.indexOf("?")!= -1)
			//|(originPath.indexOf(":")!= -1)
			||(originPath.indexOf("|")!= -1)
			||(originPath.indexOf("<")!= -1)
			||(originPath.indexOf(">")!= -1)){
		}else{
			returnCheck = true;
		}
		return returnCheck;  
	} 
	
	
}
