/*
 * GenericSheet.java
 *
 * Created on 2005/05/17,  16:06:08
 */
package jp.co.intra_mart.data_migration.common.read;

import java.util.ArrayList;
import java.util.List;

/**
 * \`f[^̍s̎舵̎łB
 *
 * @author intra-mart
 * @since 5.0
 */
public class RowsImpl implements Rows {
    /**
     * sf[^i[郊Xg
     */
    private List rows = null;

    /**
     * RXgN^
     * <br>
     * ɂ͗ {@link Columns} vfɂXgݒ肵ĉB
     * 
     * @param list vfɂXg
     */
    public RowsImpl(List list) {
        this.rows = (list != null) ? list : new ArrayList();
    }

    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Rows#getObject(int, int)
     */
    public Object getObject(int rowIndex, int columnIndex) {
        return getColumns(rowIndex).getObject(columnIndex);
    }

    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Rows#getString(int, int)
     */
    public String getString(int rowIndex, int columnIndex) {
        Object value = this.getObject(rowIndex, columnIndex);
        return (value == null) ? null : value.toString();
    }

    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Rows#getRow(int)
     */
    public Columns getColumns(int index) {
        return (index < 1 || rows.size() < index) ? new ColumnsImpl(null)
                : (Columns) rows.get(index - 1);
    }

    /* ( Javadoc)
     * @see jp.co.intra_mart.data_migration.common.util.data.Rows#size()
     */
    public int size() {
        return this.rows.size();
    }
}
