/*
 * GeneratorConstant.java
 *
 * Created on 2005/02/02, 15:59:45
 */

package jp.co.intra_mart.data_migration.common.table;

import java.util.Locale;

/**
 * 
 * 
 * @author ohyama
 * @since 5.0
 */
public interface GeneratorConstant {

	/**
	 * e[u폜Ă琶邩ǂ\tO
	 */
	public static final boolean DROP_TABLE_FLAG = false;

	/**
	 * ԃR[hJ
	 */
	public static final String COLUMN_NAME_TERM = "term_cd";

	/**
	 * ԃR[hJ^Cv
	 */
	public static final String COLUMN_TYPE_TERM = "VARCHAR(20) NOT NULL";

	/**
	 * LԊJñJ
	 */
	public static final String COLUMN_NAME_START_DATE = "start_date";

	/**
	 * LԊJñJ^Cv
	 */
	public static final String COLUMN_TYPE_START_DATE = "VARCHAR(19) NOT NULL";

	/**
	 * LԏĨJ
	 */
	public static final String COLUMN_NAME_END_DATE = "end_date";

	/**
	 * LԏĨJ^Cv
	 */
	public static final String COLUMN_TYPE_END_DATE = "VARCHAR(19) NOT NULL";

	/**
	 * P[IDJ
	 */
	public static final String COLUMN_NAME_I18N = "locale_id";

	/**
	 * P[IDJ^Cv
	 */
	public static final String COLUMN_TYPE_I18N = "VARCHAR(20) NOT NULL";

	/**
	 * ŏIXV҃J
	 */
	public static final String COLUMN_NAME_RECORD_USER_CD = "record_user_cd";

	/**
	 * ŏIXV҃J^Cv
	 */
	public static final String COLUMN_TYPE_RECORD_USER_CD = "VARCHAR(50) NOT NULL";

	/**
	 * ŏIXVJ
	 */
	public static final String COLUMN_NAME_RECORD_DATE = "record_date";

	/**
	 * ŏIXVJ^Cv
	 */
	public static final String COLUMN_TYPE_RECORD_DATE = "VARCHAR(19) NOT NULL";

	/**
	 * {e[uTtBbNX
	 */
	public static final String TABLE_SUFFIX_BASE = "_b";

	/**
	 * ԉe[uTtBbNX
	 */
	public static final String TABLE_SUFFIX_TERM = "_t";

	/**
	 * ۉe[uTtBbNX
	 */
	public static final String TABLE_SUFFIX_I18N = "_i";

	/**
	 * ԍۉe[uTtBbNX
	 */
	public static final String TABLE_SUFFIX_TERM_I18N = "_t_i";

	/**
	 * ŏIXV
	 */
	public static final String UPDATE_USER = "master";

	/**
	 * ŏIXV
	 */
	public static final String UPDATE_TIMESTUMP = "2005/02/09|12:00:00";

	/**
	 * gp
	 */
	public static final Locale[] LOCALES = { Locale.JAPANESE, Locale.ENGLISH,
			Locale.CHINESE };

	/**
	 * [U
	 */
	public static final int NUM_USER = 30000;

	/**
	 * [Ů
	 */
	public static final String[] TERMS_USER = { "1582/10/15|00:00:00",
			"9999/12/31|00:00:00" };

	/**
	 * А 5
	 */
	public static final int NUM_COMPANY = 4;

	/**
	 * Ж̃o[W̊
	 */
	public static final String[] VERSIONS_COMPANY = { "1582/10/15|00:00:00",
			"1980/04/01|00:00:00", "1990/04/01|00:00:00",
			"2000/04/01|00:00:00", "2010/04/01|00:00:00",
			"2020/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * Ж̊Kw 5
	 */
	public static final int NUM_LEVELS_PER_COMPANY = 4;

	/**
	 * egDɑ΂qgD 5
	 */
	public static final int NUM_SUB_DEPARTMENTS = 5;

	/**
	 * gD̊
	 */
	public static final String[] TERMS_DEPARTMENT = { "1582/10/15|00:00:00",
			"2002/04/01|00:00:00", "2004/04/01|00:00:00",
			"2006/04/01|00:00:00", "2008/04/01|00:00:00",
			"2010/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * gD̐l
	 */
	public static final int NUM_MEMBERS_PER_DEPARTMENT = 50;

	/**
	 * gDƂ̊
	 */
	public static final String[] TERMS_DEPARTMENT_ATTACH = {
			"1582/10/15|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * 及Ƃ̊
	 */
	public static final String[] TERMS_DEPARTMENT_MAIN = {
			"1582/10/15|00:00:00", "2001/04/01|00:00:00",
			"2002/04/01|00:00:00", "2003/04/01|00:00:00",
			"2004/04/01|00:00:00", "2005/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * Ж̖E
	 */
	public static final int NUM_POST_PER_COMPANY = 20;

	/**
	 * EƂ̊
	 */
	public static final String[] TERMS_POST = { "1582/10/15|00:00:00",
			"1995/04/01|00:00:00", "2000/04/01|00:00:00",
			"2005/04/01|00:00:00", "2010/04/01|00:00:00",
			"2015/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * gpE
	 */
	public static final int NUM_POST_USING = 20;

	/**
	 * pubNO[vZbg
	 */
	public static final int NUM_PUBLIC_GROUP_SET = 15;

	/**
	 * pubNO[vZbg̃o[W̊
	 */
	public static final String[] VERSIONS_PUBLIC_GROUP_SET = {
			"1582/10/15|00:00:00", "1980/04/01|00:00:00",
			"1990/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * pubNO[vZbg̊Kw
	 */
	public static final int NUM_LEVELS_PER_PUBLIC_GROUP_SET = 3;

	/**
	 * epubNO[vɑ΂qpubNO[v
	 */
	public static final int NUM_SUB_GROUPS = 3;

	/**
	 * pubNO[v̊
	 */
	public static final String[] TERMS_PUBLIC_GROUP = { "1582/10/15|00:00:00",
			"2002/04/01|00:00:00", "2004/04/01|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * pubNO[v̐l
	 */
	public static final int NUM_MEMBERS_PER_PUBLIC_GROUP = 10;

	/**
	 * pubNO[vƂ̊
	 */
	public static final String[] TERMS_PUBLIC_GROUP_ATTACH = {
			"1582/10/15|00:00:00", "9999/12/31|00:00:00" };

	/**
	 * [ŨvCx[gO[v
	 */
	public static final int NUM_PRIVATE_GROUP_PER_OWNER = 3;

	/**
	 * vCx[gO[v̐l
	 */
	public static final int NUM_MEMBERS_PER_PRIVATE_GROUP = 50;

	/**
	 * [
	 */
	//    public static final int NUM_ROLE = 1000;
	public static final int NUM_ROLE = 300;

	/**
	 * Kwŏʃ[
	 */
	public static final int NUM_PARENT_ROLE = 6;

	/**
	 * [̊Kw
	 */
	public static final int NUM_LEVELS_PER_ROLE = 3;

	/**
	 * [̃Tu[
	 */
	//    public static final int NUM_SUB_ROLES = 5;
	public static final int NUM_SUB_ROLES = 3;

	/**
	 * [̃[U
	 */
	//    public static final int NUM_ACCOUNT_PER_ROLE = 2000;
	public static final int NUM_ACCOUNT_PER_ROLE = 200;

	/**
	 * [JeS
	 */
	public static final int NUM_CATEGORY = 2;

	/**
	 * [JeS̃[
	 */
	public static final int NUM_ROLE_PER_CATEGORY = 2;

	/**
	 * fJeS
	 */
	public static final int NUM_BULLETIN_CLASS = 30;

	/**
	 * fJeS̊Kw
	 */
	public static final int NUM_LEVELS_PER_CLASS = 3;

	/**
	 * fJeŠ
	 */
	public static final int NUM_INFOS_PER_CLASS = 300;

	/**
	 *  fJeS30*3
	 */
	public static final int NUM_RESOURCE_USING = NUM_BULLETIN_CLASS
			* NUM_LEVELS_PER_CLASS;

	/**
	 * ARTICLE f30*3*300
	 */
	public static final int NUM_ARTICLE_USING = NUM_BULLETIN_CLASS
			* NUM_LEVELS_PER_CLASS * NUM_INFOS_PER_CLASS;

	/**
	 * fJeSƂ̊
	 */
	public static final String[] NTC_START_END_DATE = { "2000/04/01|00:00:00",
			"2010/04/01|00:00:00" };

	/**
	 * XPW[̊ 
	 */
	public static final int NUM_SCHEDULE_DAY = 240;

	/**
	 * XPW[̊Ԗ̌
	 */
	public static final int NUM_SCHEDULE_PER_DAY = 3;

	/**
	 * ID
	 */
	public static final int NUM_ID_USING = 100000000;

	/**
	 * File size 100M 10M for test
	 */
	public static final int SIZE_FILE_LIMIT = 1000000;

	/**
	 * facilites grp num
	 */
	public static final int NUM_FACT_GRP = 30;

	/**
	 * facilites grp
	 */
	public static final int NUM_FACT = 3;

	/**
	 * facilites day
	 */
	public static final int NUM_FACILITIES_DAY = 240;

	/**
	 * facilites per day
	 */
	public static final int NUM_FACILITIES_PER_DAY = 3;
	/**
     * ̃[U
     */
	public static final int NUM_USERS_TRVT=10000;
	
	/**
     * ̌
     */
	public static final int NUM_TRVT=100;
	
	/**
     * Ζ̊ 
     */
	public static final int NUM_WROK_DAY=240;
	/**
	 * seat day
	 */
	public static final int NUM_SEAT_DAY=120;
	
	/**
	 * seat react
	 */
	public static final int NUM_SEAT_REACT=3;
	
	/**
	 * seat content
	 */
	public static final int NUM_SEAT_CONTENT=3;
	
	/**
	 * FOLDER Kw
	 */
	public static final int NUM_LEVELS_FOLDER = 3;

	/**
	 * FOLDER Kw̌
	 */
	public static final int NUM_PER_FOLDER = 3;

	/**
	 * FOLDER Kw̌
	 */
	public static final int NUM_DOCS_PER_FOLDER = 20;

	/**
	 * Writer out true==>db false=>sql file
	 */
	public static final boolean OUT_DB_FLAG = true;
	
	/**
	 * db batch size
	 */
	public static final int NUM_DB_BATCH = 1000;
	
	/**
	 * ISPŏIXV
	 */
	public static final String ISP_UPDATE_USER = "ispmaster";
	
	/**
	 * schedule break point,namely start point
	 */
	public static final int SCHEDULE_BREAK_POINT=0;
	
	/**
	 * schedule index break point
	 */
	public static final int SCHEDULEINDEX_BREAK_POINT=0;
}